<template>
    <div>
        <input
            class="form-control phone-input"
            type="tel"
            :value="value"
            @input="change"
            :placeholder="placeholder"
            :name="name"
        >
    </div>
</template>

<script>
import InputMask from "inputmask";
import MaskedInput from 'vue-text-mask';

export default {
    name: "PhoneInput",
    components: {
        MaskedInput,
    },
    props: {
        value: {
            type: [String],
            default: '',
        },
        id: {
            type: String,
            default: 'name',
        },
        name: {
            type: String,
            default: 'name',
        },
        placeholder: {
            type: String,
            default: ''
        },
    },
    mounted() {
        let selector = document.getElementsByClassName('phone-input');
        this.bindPhoneMask(selector);
    },
    methods: {
        change(value) {
            if (!value.target.value) return;
            let val = value.target.value;

            if (val[0] === '8') {
                val = val.toString().replace('8', '+7');
            }
            if (val.toString().replace(/[^0-9]+/g, '') === '789') {
                val = '79';
            }
            this.$emit('input', val);
        },
        bindPhoneMask(inputElement, regexMask = null, placeholder = null) {
            if (!regexMask) regexMask = '^\\+7 \\([89]\\d\\d\\) \\d\\d\\d \\d\\d \\d\\d$';
            if (!placeholder) placeholder = '+7 (___) ___ __ __';

            InputMask({
                regex: regexMask,
                placeholder: placeholder,
                postValidation: buffer => {
                    let nums = buffer.join('').toString().replace(/[^0-9]+/g, '');
                    let hasSevenNumbersInARow = (/(\d)\1{6}/g).test(nums);
                    return !hasSevenNumbersInARow;
                }
            }).mask(inputElement);
        },
    }
}
</script>
